#include "ticket.h"
#include "ui_ticket.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QMessageBox>
#include <QComboBox>
#include <QFile>
#include <QTextStream>


Ticket::Ticket(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Ticket)
{
    ui->setupUi(this);

}

Ticket::~Ticket()
{
    delete ui;
}

void Ticket::on_buttonBox_accepted()
{
    QMessageBox msgBox;
    QString strFileDirectory ="/home/ashish/VertigoFlightBooking/VertigoFlightBooking/";
    QString strFileName =strFileDirectory;
    QString strUniqueIdFileName =strFileDirectory;
    QString strbookFileName=strFileDirectory;
    QString strName;
    QString strAge;
    QString strGender;
    QString strPhone;
    QString strFromDestination;
    QString strToDestination;
    QString strJourneyDate;
    QString strReadline;
    QString strUniqueTicketId;
    int iUniqueTicketId;
    int iTickets;

    strName=ui->txtName->text();
    strAge=ui->txtAge->text();
    strGender=ui->comboBox->currentText();
    strPhone=ui->txtPhone->text();

    //Fetch Destination details
    strFileName.append("DestinationDetails.txt");
    QFile file(strFileName);
    if(file.exists())
    {
        file.open(QIODevice::ReadOnly | QIODevice::Text);
        //while(!file.atEnd())
        {
            strReadline=file.readLine();
            QStringList jStringList=strReadline.split(",");
            strFromDestination=jStringList[0];
            strToDestination=jStringList[1];
            strJourneyDate=jStringList[2];

        }

    }
    file.close();

    //Gets unique ticket id
     strUniqueIdFileName.append("uniqueticked.txt");
     QFile infile(strUniqueIdFileName);
     if(file.exists())
     {
         infile.open(QIODevice::ReadOnly | QIODevice::Text);
         strReadline=infile.readLine();
         iUniqueTicketId=strReadline.toInt();
     }


     //To Book a seat
     strbookFileName.append("PassengerDetails.txt");
     QFile outfile(strbookFileName);
     iUniqueTicketId++;
     strUniqueTicketId=QString::number(iUniqueTicketId);
     if(!outfile.exists())
     {
         outfile.open(QIODevice::WriteOnly | QIODevice::Text);
         QTextStream out(&outfile);
         out << strUniqueTicketId+","+strName+","+strAge+","+strGender+","+strPhone+","+strFromDestination+","+strToDestination+","+strJourneyDate;
     }
     else
     {
          outfile.open(QIODevice::Append | QIODevice::Text);
          QTextStream out(&outfile);
          out << '\n'+strUniqueTicketId+","+strName+","+strAge+","+strGender+","+strPhone+","+strFromDestination+","+strToDestination+","+strJourneyDate;
     }

     outfile.close();


     //Update the unique Id
     QFile outuniquefile(strUniqueIdFileName);
     if(outuniquefile.exists())
     {
         outuniquefile.open(QIODevice::WriteOnly | QIODevice::Text);
         QTextStream out(&outuniquefile);
         out << strUniqueTicketId;
     }
     outuniquefile.close();

     //Update the booked ticket count

     QStringList kStringList=strJourneyDate.split("/");
     QString strJourneyDateFileName=strFileDirectory+kStringList[0]+"_"+kStringList[1]+"_"+kStringList[2]+".txt";

     QFile inBusFile(strJourneyDateFileName);

     QString strDesintaion=strFromDestination+","+strToDestination;
     QString strFileData;
     if(inBusFile.exists())
     {
         inBusFile.open(QIODevice::ReadOnly | QIODevice::Text);
         while(!inBusFile.atEnd())
         {
             strReadline=inBusFile.readLine();
             if(strReadline.contains(strDesintaion))
             {
                QStringList lStringList=strReadline.split(",");
                QString strTicket=lStringList[2];
                iTickets=strTicket.toInt();
                iTickets++;
                strTicket=QString::number(iTickets);
                strFileData+=lStringList[0]+","+lStringList[1]+","+strTicket+"\n";
             }
             else
             {
                 strFileData+=strReadline;
             }

         }

     }
     inBusFile.close();


     QFile outBusfile(strJourneyDateFileName);

     if(outBusfile.exists())
     {
         outBusfile.open(QIODevice::WriteOnly | QIODevice::Text);
         QTextStream out(&outBusfile);
         out << strFileData;
     }

     outBusfile.close();


    //strMessage="Ticket Succesfully booked.\nTicket Id is";
    msgBox.setText("Ticket Succesfully booked.\nTicket Id is "+strUniqueTicketId);
    int ret = msgBox.exec();
}

void Ticket::on_buttonBox_rejected()
{
    QMessageBox msgBox;
    msgBox.setText("Ticket Booking canceled.");
    int ret = msgBox.exec();
}
